VERSION 4.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "16-Color Bitmap Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  BITMAP16.FRM                                                              *
'                                                                            *
'  This program demonstrates how to translate a 16-color bitmap to the 256-  *
'  color format, and display the resulting 256-color image.                  *
'                                                                            *
'*****************************************************************************

Const vbWidth = 320
Const vbHeight = 200

Dim Bird16(20 * 20) As Byte
Dim Bird256(40 * 20) As Byte
Dim Translation(16) As Byte

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   Dim I As Integer
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call LoadArrays
   Call fg_unpack(Bird16(0), Bird256(0), 20 * 20)
   For I = 0 To 40 * 20 - 1
      Bird256(I) = Translation(Bird256(I))
   Next I

   Call fg_setcolor(20)
   Call fg_fillpage
   Call fg_move(vbWidth / 2 - 20, vbHeight / 2 + 10)
   Call fg_drwimage(Bird256(0), 40, 20)
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub

Private Sub LoadArrays()
   Dim I As Integer
   Open CurDir + "\BIRD16.DAT" For Input As #1
   For I = 0 To 20 * 20 - 1
      Input #1, Bird16(I)
   Next I
   Close #1

   Translation(0) = 0
   Translation(1) = 10
   For I = 2 To 15
      Translation(I) = I + 10
   Next I
End Sub
