VERSION 4.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Keyboard Handler Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.CommandButton Command1 
      Caption         =   "Begin"
      Height          =   375
      Left            =   2640
      TabIndex        =   0
      Top             =   3360
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  KBDEMO.FRM                                                                *
'                                                                            *
'  This program shows how to pan the contents of a virtual buffer through    *
'  a smaller window using the low-level keyboard handler.                    *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Dim X As Long, Y As Long
Dim xLimit As Long, yLimit As Long
Dim CanGoLeft As Boolean, CanGoRight As Boolean
Dim CanGoUp As Boolean, CanGoDown As Boolean

Private Sub Command1_Click()
   Command1.Visible = False
   Do
      Call CheckForPanning
   Loop While DoEvents > 0
End Sub

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_showbmp(CurDir + "\PORCH.BMP", 0)
   X = 0
   Y = 0
   CanGoLeft = True
   CanGoUp = True
   CanGoRight = False
   CanGoDown = False
End Sub

Private Sub Form_Paint()
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   If cxClient < vbWidth Then
      xLimit = vbWidth - cxClient
      If X < xLimit Then CanGoLeft = True
      If X > 0 Then CanGoRight = True
   Else
      xLimit = 0
      CanGoLeft = False
      CanGoRight = False
   End If
   If cyClient < vbHeight Then
      yLimit = vbHeight - cyClient
      If Y < yLimit Then CanGoUp = True
      If Y > 0 Then CanGoDown = True
   Else
      yLimit = 0
      CanGoUp = False
      CanGoDown = False
   End If
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub

'*****************************************************************************
'                                                                            *
' The CheckForPanning subroutine checks if any of the four arrow keys are    *
' pressed, and if so, pans in that direction if possible. It is called from  *
' the message loop in Command1_Click() when no messages are waiting.         *
'                                                                            *
'*****************************************************************************

Private Sub CheckForPanning()

   Const kbEscape = 1
   Const kbLeft = 75
   Const kbRight = 77
   Const kbUp = 72
   Const kbDown = 80

   If fg_kbtest(kbLeft) And CanGoLeft Then
      If X = 0 Then CanGoRight = True
      X = X + 1
      Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
      If X = xLimit Then CanGoLeft = False
   ElseIf fg_kbtest(kbRight) And CanGoRight Then
      If X = xLimit Then CanGoLeft = True
      X = X - 1
      Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
      If X = 0 Then CanGoRight = False
   ElseIf fg_kbtest(kbUp) And CanGoUp Then
      If Y = 0 Then CanGoDown = True
      Y = Y + 1
      Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
      If Y = yLimit Then CanGoUp = False
   ElseIf fg_kbtest(kbDown) And CanGoDown Then
      If Y = yLimit Then CanGoUp = True
      Y = Y - 1
      Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
      If Y = 0 Then CanGoDown = False
   ElseIf fg_kbtest(kbEscape) Then
      X = 0
      Y = 0
      Call fg_vbpaste(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1)
      If xLimit > 0 Then CanGoLeft = True
      If yLimit > 0 Then CanGoUp = True
      CanGoRight = False
      CanGoDown = False
   End If
End Sub
