!*****************************************************************************
!                                                                            *
!  STRINGS2.F90                                                              *
!                                                                            *
!  This program shows how to display strings in the virtual buffer. Because  *
!  WinG is needed to do this, you must link this program with the Fastgraph  *
!  for Windows WinG support library, and WinG must be available on your      *
!  system.                                                                   *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

include 'strings2.fi'

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGstrings2'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = NULL
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindow(      &
   AppName,                 &  ! window class name
   'Display Strings in Virtual Buffer'C, &  ! window caption
   WS_OVERLAPPEDWINDOW,     &  ! window style
   CW_USEDEFAULT,           &  ! initial x position
   CW_USEDEFAULT,           &  ! initial y position
   WIDTH,                   &  ! initial x size
   HEIGHT,                  &  ! initial y size
   NULL,                    &  ! parent window handle
   NULL,                    &  ! window menu handle
   hInstance,               &  ! program instance handle
   NULL)                       ! creation parameters

if (fg_getdc() == 0) then
   iret = MessageBox(window,'WinG not available!'C,'STRINGS2'C,MB_ICONSTOP.or.MB_OK)
   iret = DestroyWindow(window)
   WinMain = 0
   return
end if

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
integer*4 window, message, wParam, lParam

include 'strings2.fi'

type (T_PAINTSTRUCT) ps
integer*4 cxClient, cyClient
integer*4 hdc, hpal, hvb
integer*4 iret

save cxClient, cyClient, hdc, hpal, hvb

WindowProc = 0

select case (message)
   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)

      call fg_vbinit
      hvb = fg_vballoc(WIDTH,HEIGHT)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      call fg_setcolor(24)
      call fg_fillpage

      call fg_setcolor(19)
      call fg_fontdc(fg_getdc())

      ! upper vertical justification
      call fg_move(0,0)
      call fg_justify(-1,1)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH/2,0)
      call fg_justify(0,1)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH-1,0)
      call fg_justify(1,1)
      call fg_print('FG/Windows'C,10)

      ! centered vertical justification
      call fg_move(0,HEIGHT/2)
      call fg_justify(-1,0)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH/2,HEIGHT/2)
      call fg_justify(0,0)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH-1,HEIGHT/2)
      call fg_justify(1,0)
      call fg_print('FG/Windows'C,10)

      ! lower vertical justification
      call fg_move(0,HEIGHT-1)
      call fg_justify(-1,-1)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH/2,HEIGHT-1)
      call fg_justify(0,-1)
      call fg_print('FG/Windows'C,10)
      call fg_move(WIDTH-1,HEIGHT-1)
      call fg_justify(1,-1)
      call fg_print('FG/Windows'C,10)

      return

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_SIZE)
      cxClient = LOWORD(lParam)
      cyClient = HIWORD(lParam)
      return

   case (WM_DESTROY)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      call PostQuitMessage(0)
      return
end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end
